if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Enabled","Ranks","$Pref::Ranks::Enabled","bool","Server_Ranks",1,0,0,"checkRanks");
	RTB_registerPref("Type","Ranks","$Pref::Ranks::Type","list Linear 0 Exponential 1 Manual 2","Server_Ranks",1,0,0,"checkRanks");
	RTB_registerPref("Stat Used","Ranks","$Pref::Ranks::Controller","list Score 0 Kills 1","Server_Ranks",1,0,0,"checkRanks");
	RTB_registerPref("Difficulty","Ranks","$Pref::Ranks::Difficulty","int 1 10","Server_Ranks",5,0,0,"checkRanks");
	RTB_registerPref("Save Ranks","Ranks","$Pref::Ranks::Save","bool","Server_Ranks",1,0,0);

}
else
{
	$Pref::Ranks::Enabled = true; //Toggles the mod
	$Pref::Ranks::Type = 1; //Linear (0) for static requirement, Exponential (1) for increasing requirement, Manual (2) for manual control
	$Pref::Ranks::Controller = 1; //Score (0) for a score requirement, Kills (1) for a kill requirement
	$Pref::Ranks::Difficulty = 5; //Difficulty of ranking
	$Pref::Ranks::Save = 1; //Saves ranks
}

exec("./ranks.cs");

package RankVars
{
	function VCE_initServer()
	{
		Parent::VCE_initServer();
		registerSpecialVar(GameConnection,"rank","%this.rank");
		registerSpecialVar(GameConnection,"rankExp","$Pref::Ranks::Controller ? %this.killCount : %this.score");
		registerSpecialVar(GameConnection,"rankReq","mPow($Pref::Ranks::Difficulty*%this.rank,2/(2-$Pref::Ranks::Type))");
	}
};
activatePackage(RankVars);

function checkRanks(%oldVal, %newVal)
{
	for(%c = 0; %c < clientGroup.getCount(); %c++)
	{
		%client = clientGroup.getObject(%c);
		%client.schedule(100, "SetRank");
	}

	if($Pref::Ranks::Enabled)
		activatePackage(Ranks);
	else
		deactivatePackage(Ranks);
}